include \masm32\include\masm32rt.inc

ChkProcess proto pszName:ptr CHAR,ppPID:ptr PDWORD

.code
main proc
LOCAL pPID:PDWORD

	fn ChkProcess,"Explorer.exe",ADDR pPID
	.if eax
		mov esi,eax
		print "number of instances: "
		print str$(esi),13,10
		xor edi,edi
		mov ebx,pPID
		.while edi < esi
			print "#"
			print str$(ADDR [edi+1])
			print ": "
			print str$(DWORD ptr [ebx+edi*4]),13,10
			lea edi,[edi+1]
		.endw
		free pPID
	.endif
	
	inkey
	exit
	
	ret
main endp

PCREATETOOLHELP32SNAPSHOT 	typedef ptr pr2
PPROCESS32FIRST 			typedef ptr pr2
PROCESS32NEXT	 			typedef ptr pr2

; pszName: ptr to string, e.g.: "explorer.exe"
; ppPID:   pointer to varibale, which will recive a pointer 
;          to an array of DWORD's (PIDs) - this buffer must 
;          be freed using GlobalFree().
; RETURN:  The number of running instances. If this value is zero, ppPID is not used.
ChkProcess proc uses edi ebx esi pszName:ptr CHAR,ppPID:ptr PDWORD
LOCAL pCreateToolhelp32Snapshot:PCREATETOOLHELP32SNAPSHOT
LOCAL pProcess32First:PPROCESS32FIRST
LOCAL pProcess32Next:PROCESS32NEXT
LOCAL hSnapShot:HANDLE
LOCAL pe:PROCESSENTRY32	

	mov ebx,rv(GetModuleHandle,"kernel32.dll")
	mov pCreateToolhelp32Snapshot,rv(GetProcAddress,ebx,"CreateToolhelp32Snapshot")
	mov pProcess32First,rv(GetProcAddress,ebx,"Process32First")
	mov pProcess32Next,rv(GetProcAddress,ebx,"Process32Next")
	
	xor esi,esi
	mov hSnapShot,rv(pCreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,0)
	mov pe.dwSize,SIZEOF pe
	.while rv(pProcess32First,hSnapShot,ADDR pe)
		.if !rv(szCmpi,ADDR pe.szExeFile,pszName,len(pszName))
			lea esi,[esi+1]
			push pe.th32ProcessID
		.endif
		invoke pProcess32Next,hSnapShot,ADDR pe
	.endw
	invoke CloseHandle,hSnapShot
	.if esi
		lea ebx,[esi*4]
		mov edi,alloc(ebx)
		mov edx,esp
		invoke RtlMoveMemory,edi,edx,ebx
		add esp,ebx
		mov edx,ppPID
		mov PDWORD ptr [edx],edi
		mov eax,esi
		ret
	.endif
	xor eax,eax
	ret
	
ChkProcess endp
end main